net.sf.saxon.regex

## Class ATokenIterator

- java.lang.Object
- - net.sf.saxon.regex.ATokenIterator

- All Implemented Interfaces:
    SequenceIterator<StringValue>

      public class ATokenIterator
      extends Object
      implements SequenceIterator<StringValue>

  A ATokenIterator is an iterator over the strings that result from tokenizing a string using a regular expression

- - ### Field Summary

    - ### Fields inherited from interface net.sf.saxon.om.SequenceIterator

      `GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ATokenIterator(UnicodeString input, REMatcher matcher)` Construct an ATokenIterator.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close the iterator.
    `StringValue` | `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
    `ATokenIterator` | `getAnother()` Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.
    `int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
    `StringValue` | `next()` Get the next item in the sequence.
    `int` | `position()` Get the current position.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ATokenIterator

          public ATokenIterator(UnicodeString input,
                        REMatcher matcher)

      Construct an ATokenIterator.

  - ### Method Detail

    - #### next

          public StringValue next()

      Description copied from interface: `SequenceIterator`
      Get the next item in the sequence. This method changes the state of the iterator, in particular it affects the result of subsequent calls of position() and current().
      Specified by:
        `next` in interface `SequenceIterator<StringValue>`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.

    - #### current

          public StringValue current()

      Description copied from interface: `SequenceIterator`
      Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next(). This method does not change the state of the iterator.
      Specified by:
        `current` in interface `SequenceIterator<StringValue>`
      Returns:
        the current item, the one most recently returned by a call on next(). Returns null if next() has not been called, or if the end of the sequence has been reached.

    - #### position

          public int position()

      Description copied from interface: `SequenceIterator`
      Get the current position. This will usually be zero before the first call on next(), otherwise it will be the number of times that next() has been called. Once next() has returned null, the preferred action is for subsequent calls on position() to return -1, but not all existing implementations follow this practice. (In particular, the EmptyIterator is stateless, and always returns 0 as the value of position(), whether or not next() has been called.)

      This method does not change the state of the iterator.

      Specified by:
        `position` in interface `SequenceIterator<StringValue>`
      Returns:
        the current position, the position of the item returned by the most recent call of next(). This is 1 after next() has been successfully called once, 2 after it has been called twice, and so on. If next() has never been called, the method returns zero. If the end of the sequence has been reached, the value returned will always be <= 0; the preferred value is -1.

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

      Specified by:
        `close` in interface `SequenceIterator<StringValue>`

    - #### getAnother

          public ATokenIterator getAnother()

      Description copied from interface: `SequenceIterator`
      Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.

      This method allows access to all the items in the sequence without disturbing the current position of the iterator. Internally, its main use is in evaluating the last() function.

      This method does not change the state of the iterator.

      Some implementations of this method may regenerate the input sequence, creating new nodes with different identity from the original. This is not recommended, but is hard to prevent. This causes no problem for the primary usage of this method to support the last() function, but it has been known to cause trouble in other situations.

      Specified by:
        `getAnother` in interface `SequenceIterator<StringValue>`
      Returns:
        a SequenceIterator that iterates over the same items, positioned before the first item

    - #### getProperties

          public int getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator<StringValue>`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.